# In this directory there was initially just the following files.
#   image1.fts, image2.fts - fits files after image processing steps complete.
#   stars.cat              - a list of stars for which photometry is required.
#   psf.cat                - a list of stars for psf determination.
#
# The following script is then run, as an example of doing time-series 
# photometry.

# If you want to show you can reproduce the results, copy the above four files
# into an empty directory, and then run this script.

# set ARKEXE to point to a likely place, you may need to reset this.
setenv ARKEXE ~/Opt_Public/exe

# Run pix_info.  This sets up a flag file which contains the bad pixels, and
# puts various crucial items into the header.  The resulting files are called
# hmage?.fts and hmage?.pix
$ARKEXE/pix_info <<EOF
1 375 1 241
16000
32000
6.7


end
image?.fts
end
EOF

# Run mapccd to calculate the offsets beween the frames.  
# The output file is called offsets.dat.
$ARKEXE/mapccd<<EOF
2
10
no
hmage?.fts
end
end
EOF

# Finally run opphot to to get the photometry out.  The output files for
# each stars are called star??.opt
$ARKEXE/opphot<<EOF
psf.cat
3
stars.cat
3
offsets.dat
end
-1 -1
5
5
-1
EOF
