# This is a script which will recompile the programs for you.  Be warned, it
# deletes out the old versions!

# You may need to change some of the following, and take a special look 
# at the following line, which should be set up with the name of the
# directory you have copied the stuff into.  E.g. setenv ARKDIR ~/Opt_Public.

setenv ARKDIR ~/Opt_Public

setenv ARKCOM  $ARKDIR/com
setenv ARKFOR  $ARKDIR/for

setenv ARKEXE  $ARKDIR/exe
setenv ARKOBJ  $ARKDIR/obj
setenv ARKMOD  $ARKDIR/mod

# Delete out some things.
rm $ARKEXE/*
rm $ARKOBJ/*
rm $ARKMOD/*

# We are O.K. without this as long as we don't write a fits file.  And even
# ten in most OS it will work.
setenv ARK_OS   `uname`

# Only put these bits of the path in if they have not been set already.
if (`echo ${PATH} | grep -c ark/exe` == 0) setenv PATH {$ARKEXE}:$PATH

# Now things that make will need.  First a compiler.  I recommend using 
# g95 which is available free onthe web.  I use it with some odd options.
setenv FC  "g95 -fno-second-underscore -O2 -I$ARKMOD"
setenv FCC "g95 -fno-second-underscore -fbounds-check -O0 -I$ARKMOD"

# If you want mapccd you will need X11.
setenv LINKX11 "-L/usr/X11R6/lib -lX11"

# Now makes the bits of infrastructre we need.
cd $ARKFOR/System/Unix
make -f system.make
cd $ARKFOR/System
make -f system.make
cd $ARKFOR/Arkplot
make -f tplot.make
cd $ARKFOR/marquardt
make -f marq.make
cd $ARKFOR/Cluster
make -f define_star.make

# Now lets make Opphot and mpaccd.
cd $ARKFOR/Opphot
make -f opphot.make
make -f mapccd.make

# Now pix_info.
cd $ARKFOR/head
make -f pix_info.make
