        subroutine linxy(x,y)
 
c       Draws a line from the current position to (x,y) and then moves
c       current position to (x,y).  Tektronix version.
c       Tim Naylor
 
c       Passed variables.
        real x, y
c       When converted into device units.
        real xd, yd

c       Common block for the current position in hardware co-ordinates.        
        real xc, yc
        common/cpos/xc, yc

c       Common block for the user to hardware co-ordinate conversion.
        real fx, xb, fy, yb
        common/conv/fx, xb, fy, yb                                              

c       For the integers representing the current positions.
        integer i1, i2, i3, i4
        common /tekpos/ i1, i2, i3, i4

c       The common block for the tektronix command strings.
        character*20 cgr, cal, device
        integer ngr, nal
        common /tekstr/ cgr, ngr, cal, nal, device

        integer n1, n2, n3


c       Convert to device units.
        xd=(x-xb)*fx
        yd=(y-yb)*fy
        if (device .eq. 'x11') then
          call x11(' ', xc, yc, xd, yd, 0, 12)
        else
          n1=nint(yd)/32+32
          n2=mod(nint(yd),32)+96
          n3=nint(xd)/32+32
          i4=mod(nint(xd),32)+64
c         Send only those bits which have changed.
c         Send the High Y bit.
          if (n1 .ne. i1) call sendit(char(n1))
c         And the low Y bit.
          if (n2.ne.i2 .or. n3.ne.i3) call sendit(char(n2))
c         And the high X bit.
          if (n3 .ne. i3) call sendit(char(n3))
c         We must send the low X bit.
          call sendit(char(i4))
          i1=n1
          i2=n2
          i3=n3
        end if

c       Update the current co-ordinates.
        xc=xd
        yc=yd

900     call errhnd('LINXY', 'SUCCESS', ' ')
        end
