        subroutine pltopn(if)
 
c       Initialises  everything,  changes  to  graphics  mode  and  clears
c       graphics screen.

c       Note that for VAXes the spawn lines have to in the code, for
c       UNIX systems commented out (this is so that you can use the
c       quick spawn, rather than the slow one given by ARKCOM).

c       Tim Naylor.
 
        logical set, assume, before, lwork
        integer if, ipos

c       The common block for the tektronix command strings.
        character*20 cgr, cal, device
        integer ngr, nal
        common /tekstr/ cgr, ngr, cal, nal, device

c       Unit number and file name for file output.
        integer ifile
        character file*20, ark_os*3
        common/ofil/ifile, file

c       Functions called.
        logical arkgsm, arkssm

c       Screen sizes and offsets in hardware co-ordinates.
c       All you have to change is xpap and ypap for different devices.
        real xpap, ypap, xoff, yoff
        integer jspare
        common/area/xpap, ypap, xoff, yoff, jspare

        data assume /.true./
        data before /.false./

c       The logical before sees if the device has been opened, etc. 
c       if it has then...
        if (before) goto 700

        xpap=1023.00
        ypap=779.00
        xoff=0.0
        yoff=0.0
                              

 
c       Find out which operating system you're using.
        lwork=arkgsm('ARK_OS', ark_os)

c       Has the device already been chosen?
        set=arkgsm('ARK_PLOT', device)
100     if (.not. set) then
c         If not, then prompt for it.
	  print*, '* The ARK plotting package will work on the;'
	  print*, '* cifer_t4      datatype_920c'
	  print*, '* cifer_t5      pericom_mg'
          print*, '* cifer_2634    GraphOn_235'
          print*, '* kermit_ms     X11 (X window)'
          print*, '* tek (A pure Tektronix emulation.)'
          print*, '> Which device are you using?'
          read (*, '(a)') device
          if (device .eq. 'tek') then
c           The user may want to use an auxiliary device.
            print*, '* Want to use a different terminal for graphics?'
            print*, '> If so give its name (e.g. tta3:), othewise <cr>.'
            read (*, '(a)') file
            if (file .ne. ' ') then
              device='tek/'//file
            end if
          end if
        end if
        call locase(device)

c       Tell the common block the file to be used.
        if (ark_os .eq. 'VMS') then 
          ifile=if
          file='SYS$OUTPUT' 
        else
          ifile=6
          file='unix-term'
        end if

c       The idea here is to fill the array cgr with whatever puts the 
c       terminal into Tektronix emulation mode, and make ngr equal to
c       the number of characters in this string.  The  array  cal
c       is  filled  with  the  nal characters which mean "return to normal
c       alpha mode".
        if (device.eq.'cifer_t4' .or. device.eq.'cifer_t5') then
c         Cifer T series (well at least T4 and T5).
          write(cgr, '(3a)') char(27), char(80), char(116)
          ngr=3
          write(cal, '(2a)') char(27), char(92)
          nal=2
        else if(device .eq. 'datatype_920c') then
c         Datatype 920c.
          write(cgr, '(2a)') char(29), char(13)
          ngr=2
          write(cal, '(3a)') char(31), char(24), char(12)
          nal=3
        else if(device(1:10) .eq. 'pericom_mg') then
c         Pericom Monterey MG Series.  Only look at the first 10
c         letters so that pericom_mg200 still works.
          write(cgr, '(2a)') char(29), char(13)
          ngr=2
          write(cal, '(3a)') char(31), char(24), char(13)
          nal=3
        else if(device .eq. 'graphon_235') then
c         GraphOn 235 seems to be same as Pericom Monterey MG200.
          write(cgr, '(2a)') char(29), char(13)
          ngr=2
          write(cal, '(3a)') char(31), char(24), char(13)
          nal=3
        else if (device .eq. 'kermit_ms') then
          write(cgr, '(6a)') char(27), '[?38h'
          ngr=6
          write(cal, '(6a)') char(27), '[?38l'
          nal=6
        else if (device(1:3) .eq. 'tek') then
c         Real Tektronix are already in Tek mode!
          ngr=0
c         Real Tektronix have no separate alpha screen, so put them in
c         Tektronix alpha mode.
          write(cal, '(a)') char(31)
          nal=1
          if (device(4:4) .eq. '/') then
            file=device(5:20)
            ifile=if
          end if
        else if(device .eq. 'cifer_2634') then
c         Old Cifers.
          write(cgr, '(3a)') char(27), char(94), char(18)
          ngr=3
c         Exit to Tektronix alpha, and then change to alpha screen.
          write(cal, '(4a)') char(31), char(27), char(94), char(84)
          nal=4
        else if (device .eq. 'decw' .or. device.eq.'x11') then
          device='x11'
          goto 400
        else
          print*, '* Here is a error message from the ARK plotting'
          print*, '* package s/r pltopn.'
          print*, '* Unkown terminal type ', device
          set=.false.
          goto 100
        end if

c       Now for the open statement.
c       In UNIX versions we simply place whatever the local FORTRAN deems
c       to be the "no carriage return" sepcifier at the end of each write
c       statement.  Thus there is no need to open a file unless an
c       auxilary device is being used.  However for VAXes a factor of 2 or
c       more in speed results from opening the file unformatted.  The
c       "recordtype='variable'" (which is non-standard fortran) then stops
c       the cursor read crashing.
        if (ark_os .eq. 'VMS') then
c   These two lines need to be put back for VMS
c          open (unit=ifile, file=file, form='unformatted', err=800,
c     +    recordtype='variable', status='unknown')
        else if (file .ne. 'unix-term') then
          open(unit=ifile, file=file, err=800, status='unknown')
        end if 

c       Now a VAX specific, set auxilary devices into nowrap mode, so that
c       no carriage returns are put into the output stream.
c       Note that SYS$OUTPUT is put into nowrap mode in totek, and brought
c       out again in pltend (or, equivelently pltcls).
        if (file.ne.'SYS$OUTPUT' .and. ark_os.eq.'VMS') then
c         call lib$spawn('set terminal '//file//' /nowrap',,,6)
        end if

400     if (.not. set) then
          print*, '* You could have chosen this before running the'
          print*, '* package using DCL symbol/UNIX enviroment'
          print*, '* variable ARK_PLOT.'
	  set=arkssm('ARK_PLOT', device)
	  if (set) 
     &    print*, '* The symbol has now been set for future reference.'
        end if
c       No need to do this again.
        before=.true.
 
c       Now send "go into graphics" and "clear graphics screen".
c       Deal with weird cases first.
700     if (device .eq. 'cifer_2634') then
          call totek()
c         The only way to clear the screen is to go out of graphics again
c         with...
          call sendit(char(27)) 
          call sendit(char(94))
          call sendit(char(85))
c         And back into into graphics.
          call totek()
c       else if (device .eq. 'tek/opa0:') then
c         if (assume) then
c           print*, '* I am assuming this is the VILSPA Tektronix.'
c           assume=.false.
c         end if
c         Reset for VILSPA TEK4125, rather than CLS.  Brutal, but it works!
c         call sendit(char(27))
c         call sendit(char(75))
c         call sendit(char(86))
c         call sendit(char(29))
c         call lib$spawn('wait 00:00:08')
c         call totek()
        else if (device .eq. 'x11') then
          call x11(' ', xpap, ypap, xoff, yoff, jspare, 9)
        else
          call totek()
c         The next line might be CLS for Tektronix, needs confirming.
          call sendit(char(27))
          call sendit(char(12))
        end if

c       Select default font.
        call font('Q')
 
        call errhnd('PLTOPN', 'SUCCESS', ' ')
	return
 
800     print*, '* Error opening device.'
	print*, '* Please nominate a different device.'
	set=.false.
        goto 100
 
        end
