C     CONTOUR LINE GENERATING PROGRAMME
C
C     CALLING SEQUENCE
C
C     CALL CONTOR(XMIN,YMIN,XMAX,YMAX,ARRAY,N,M,VALUE,IV)
C
C     XMIN,XMAX,YMIN,YMAX DEFINE THE RECTANGLE WITHIN WHICH
C             THE CONTOUR PLOT WILL BE CONTAINED
C
C     ARRAY IS THE N BY M ARRAY OF DATA TO BE CONTOURED
C
C     VALUE IS THE VECTOR OF LENGTH IV OF VALUES AT WHICH
C             CONTOUR LINES WILL BE GENERATED
C
C
      SUBROUTINE CONTOR(XMIN,YMIN,XMAX,YMAX,ARRAY,N,M,VALUE,IV)
C
C*****PUNCHED : AJN 141178
C*****   NOTE ORDER OF CALLING SEQUENCE HAS BEEN CHANGED
C         -----------------------------------------------
C
      DIMENSION ARRAY(N,M),VALUE(IV)
C
        IVV=0
      MM=M-1
      NN=N-1
C
C     COMPUTE X,Y INCREMENTS
C
      DELTX=(XMAX-XMIN)/FLOAT(NN)
      DELTY=(YMAX-YMIN)/FLOAT(MM)
C
      DO 1 J=1,NN
        IDIR=J-J/2*2
      X=XMIN+(J-1)*DELTX
C
      DO 2 I=1,MM
        II=I
        IF(IDIR.EQ.0)II=MM+1-I
        Y=YMIN+(II-1)*DELTY
C
C     GET DATA VALUES FOR A CELL
C
      V1=ARRAY(J,II)
      V2=ARRAY(J+1,II)
      V3=ARRAY(J,II+1)
      V4=ARRAY(J+1,II+1)
C
C     CHECK EACH VALUE AGAINST DATA VALUES
C
        IVV=1-IVV
      DO 3 K=1,IV
        KK=K
        IF(IVV.EQ.1)KK=IV+1-K
      VAL=VALUE(KK)
      ICASE=1
C
C     RECORD OUTCOME OF COMPARISONS IN ICASE
C
      IF(VAL.GT.V1) ICASE=ICASE+1
      IF(VAL.GT.V2) ICASE=ICASE+2
      IF(VAL.GT.V3) ICASE=ICASE+4
      IF(VAL.GT.V4) ICASE=9-ICASE
C
C     TREAT EACH CASE SEPERATELY
C
      GO TO (3,4,5,6,7,8,9,10),ICASE
C
C     DO LINEAR INTERPOLATION
C
    4 X0=X+DELTX*(VAL-V1)/(V2-V1)
      Y0=Y
      X1=X
      Y1=Y+DELTY*(VAL-V1)/(V3-V1)
      GO TO 11
C
    5 X0=X+DELTX*(VAL-V1)/(V2-V1)
      Y0=Y
      X1=X+DELTX
      Y1=Y+DELTY*(VAL-V2)/(V4-V2)
      GO TO 11
C
    6 X0=X
      Y0=Y+DELTY*(VAL-V1)/(V3-V1)
      X1=X+DELTX
      Y1=Y+DELTY*(VAL-V2)/(V4-V2)
      GO TO 11
C
    7 X0=X
      Y0=Y+DELTY*(VAL-V1)/(V3-V1)
      X1=X+DELTX*(VAL-V3)/(V4-V3)
      Y1=Y+DELTY
      GO TO 11
C
    8 X0=X+DELTX*(VAL-V1)/(V2-V1)
      Y0=Y
      X1=X+DELTX*(VAL-V3)/(V4-V3)
      Y1=Y+DELTY
      GO TO 11
C
    9 X0=X+DELTX*(VAL-V1)/(V2-V1)
      Y0=Y
      X1=X
      Y1=Y+DELTY*(VAL-V1)/(V3-V1)
        CALL XXXCNT(IDIR,X0,Y0,X1,Y1)
C
C
   10 X0=X+DELTX*(VAL-V3)/(V4-V3)
      Y0=Y+DELTY
      X1=X+DELTX
      Y1=Y+DELTY*(VAL-V2)/(V4-V2)
C
C     OUTPUT THE LINE SEGMENT
C
11        CONTINUE
        CALL XXXCNT(IDIR,X0,Y0,X1,Y1)
C
    3 CONTINUE
C
    2 CONTINUE
C
    1 CONTINUE
        CALL XXXCNT(-1,X0,X0,X0,X0)
      RETURN
      END
