c       Reads the ASCII file that PGPLOT can create of the Hershey
c       font, and writes it out so the ARKPLOT routine CHPUT can
c       understand it.  The data statement for the characters is in
c       the file tmp.for, and "[[]]" should be replaced by the
c       font name.  The array of widths is in wid.for.

c       It requires as input, a list of Hershey and
c       corresponding ASCII numbers.

        integer xygrid(300,2000), nc(2000), length(2000)
        integer num, i, j, k, nread, maxlen
        integer ibuf(20), ikeep

        open (unit=1, file='grfont.txt', status='old', readonly)
        nread=0
        nc(1)=0
        length(1)=7
        xygrid(6,1)=-64
        xygrid(7,1)=-64
        do 210 j=2, 2000
          read(1,200,end=300) nc(j), length(j), (xygrid(i,j), i=1, 5)
200       format(7(2x,2i4))
          read(1,200) (xygrid(i,j),i=6,length(j))
          nread=nread+1
210     continue
        close (1)

300     open (unit=2, file='tmp.for', status='new', 
     +  carriagecontrol='list')
        open (unit=3, file='wid.for', status='new',
     +  carriagecontrol='list')
        ikeep=0
        maxlen=0
        print*, '> Give a list of Hershey and ASCII numbers.'
310     read(*,*,end=900) i, num
        do 390 j=1, nread
          if (nc(j) .eq. num) then
c           Check for (-64,0), and subtract off X min, and make zero
c           be the baseline.
            do 320 k=6, length(j)-1, 2
              if (xygrid(k,j) .ne. -64) then
                xygrid(k,j)=xygrid(k,j)-xygrid(4,j)+1
                xygrid(k+1,j)=xygrid(k+1,j)-xygrid(2,j)
              end if
320         continue
            write(2,330) i, char(i), nc(j), i
330         format('c       ASCII character number ', i3, ' = "', 
     +      a1, '" = Hershey number ', i4, /,
     +      '        data ([[]](j,',i3.3,'),j=1,npoint)/')
            if (length(j) .ge. 6) then 
              write(2,340) (xygrid(i,j),i=6,length(j))
340           format(50(5x,'+',2x,15(i3,','),/))
            end if
            write(2,350) 130-length(j)+5
            maxlen=max(maxlen,length(j)-5)
350         format(5x,'+',2x,i3.3,'*0')
            write(2,360)
360         format('     +  /')
            ikeep=ikeep+1
            ibuf(ikeep)=xygrid(5,j)-xygrid(4,j)+1
            if (ikeep .eq. 20) then
              write (3,370) ibuf
370           format (5x,'+  ',20(i2.2,','))
              ikeep=0
            end if
            goto 310
          end if
390     continue

900     write (3,370) (ibuf(i),i=1,ikeep)
        close (3)
        close (2)
        print*, '* Biggest character had ', maxlen, ' points.'
        end
