      module gifplot

      implicit none

      integer :: maxidx
*     The unit number for the output file.
      integer :: unit
*     The size of the image.
      integer :: bx, by
*     The pixel map.
!      byte, allocatable :: pixmap(:,:)
      integer*1, allocatable :: pixmap(:,:)
*     The current co-ordinates.
      real :: xc, yc
*     The current colour.
      integer :: ic

*     Is there are plot open?
      logical plotting
      data plotting /.false./

*     The colour table, and its default values.
      integer, dimension(3,0:255) :: CTABLE
      integer, dimension(3,0:15) :: CDEFLT

      DATA CDEFLT /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1             000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2             255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3             128,000,255, 255,000,128, 085,085,085, 170,170,170/

      contains

        subroutine pltopn1()

*       Opens the plot.

*       Locals
        character*9 :: file
        integer :: i, j, ifile
        logical :: there

*       The size of the plotting area (to be passed back to limitm).
        real xpap, ypap, xoff, yoff
        integer jspare
        common/area/xpap, ypap, xoff, yoff, jspare                              
      
*       if (plotting) call pltend1()

        file='ark??.gif'
        do j=1, 99
          write(file(4:5),'(i2.2)') j
          inquire(file=file, exist=there)
          if (.not. there ) then
            call arkopn(unit, file, ' ', 'new', 'overwrite', 
     &      'formatted', ' ', 0)
            print*, '* Opened a file called ', file
            plotting = .true. 
            goto 20
          end if
        end do
        print*, '* There are already 99 gif files in this directory.'
        print*, '* You cannot have any more, so SOD OFF!'
        stop


20      MAXIDX=0
*       Initialize color table
        DO I=0,15
          CTABLE(1,I) = CDEFLT(1,I)
          CTABLE(2,I) = CDEFLT(2,I)
          CTABLE(3,I) = CDEFLT(3,I)
        end do
        DO I=16,255
          CTABLE(1,I) = 128
          CTABLE(2,I) = 128
          CTABLE(3,I) = 128
        end do
*       Set the current colour
        ic=1

*       Image size hard coded in here.
        BX = 501
        BY = 501
        allocate(pixmap(bx,by))
        CALL GRGI03(1, 1, BX, BY, 0, BX, BY, PIXMAP)

*       Tell the rest of the package about the device.
        xoff=0.0
        yoff=0.0
        xpap=bx
        ypap=by

*       And set the font.
        call font('Q')

        end subroutine pltopn1

        subroutine movxy1(x, y)

*       Moves the pen to (x,y).
        real x, y

        xc=x
        yc=y

        end subroutine movxy1


        subroutine linxy1(x, y)

*       Draws a line from the current position to (x,y).

*       Inputs.
        real :: x, y

*       Locals.
        integer :: ix0, ix1, iy0, iy1

*       Common block for the user to hardware co-ordinate conversion.
        real :: fx, xb, fy, yb
        common/conv/fx, xb, fy, yb                                              

        ix0=nint((xc-xb)*fx)+1
        iy0=nint(by - (yc-yb)*fy )
        ix1=nint((x-xb)*fx)+1
        iy1=nint(by - (y-yb)*fy )
        CALL GRGI01(IX0, IY0, IX1, IY1, IC, BX, BY, PIXMAP)

*       Update the current co-ordinates.
        xc=x
        yc=y

        end subroutine linxy1


        subroutine pltend1()

*       Closes the file, and finishes up work.

        integer*2, allocatable :: work(:,:)

        allocate(work(4098,256)) 
        CALL GRGI06(UNIT, BX, BY, CTABLE, PIXMAP, MAXIDX, WORK)
        close(unit)
        deallocate(work)
        deallocate(pixmap)
        plotting=.false.

        end subroutine pltend1

        
      SUBROUTINE GIDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)

      INTEGER IFUNC, NBUF, LCHR, MODE
      REAL    RBUF(*)
      CHARACTER*(*) CHR

      INTEGER IER, I, L, IOS, IX0, IY0, IX1, IY1
      INTEGER GRGMEM, GRFMEM
      CHARACTER*80 MSG, INSTR, FILENM
      SAVE FILENM

C-----------------------------------------------------------------------
C
      if (ifunc .eq. 15) then
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      MAXIDX = MAX(MAXIDX, IC)
      RETURN
      else if (ifunc .eq. 21) then
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      I = RBUF(1)
      CTABLE(1, I) = NINT(RBUF(2)*255)
      CTABLE(2, I) = NINT(RBUF(3)*255)
      CTABLE(3, I) = NINT(RBUF(4)*255)
      RETURN

      else 
       print*, 'Ifunc was ', ifunc
      end if

      end subroutine gidriv

      end module gifplot

**GRGI01 -- PGPLOT GIF driver, draw line
*+
      SUBROUTINE GRGI01 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY
!      BYTE PIXMAP(BX,BY)
      integer*1 PIXMAP(BX,BY)
*
* Draw a straight-line segment from absolute pixel coordinates
* (IX0, IY0) to (IX1, IY1).
*                                                          
* Arguments:
*  ICOL            (input): Color index
*  PIXMAP   (input/output): The image data buffer.
*-----------------------------------------------------------------------
      INTEGER IX, IY, IS
      REAL    D
!      BYTE    VAL
      integer*1    VAL
*
      VAL = ICOL
      IF (IX0.EQ.IX1 .AND. IY0.EQ.IY1) THEN
         PIXMAP(IX0,IY0)=VAL
      ELSE IF (ABS(IY1-IY0).GT.ABS(IX1-IX0)) THEN
         D=(IX1-IX0)/REAL(IY1-IY0)
         IS=1       
         IF (IY1.LT.IY0) IS=-1
         DO 10 IY=IY0,IY1,IS
            IX=NINT(IX0+(IY-IY0)*D)
c           print*, 'pixel ', ix, iy, val, pixmap(ix,iy)
            PIXMAP(IX,IY)=VAL
 10      CONTINUE
      ELSE
         D=(IY1-IY0)/REAL(IX1-IX0)
         IS=1
         IF (IX1.LT.IX0) IS=-1
         DO 20 IX=IX0,IX1,IS
            IY=NINT(IY0+(IX-IX0)*D)
c           print*, 'pixel ', ix, iy, val, pixmap(ix,iy)
            PIXMAP(IX,IY)=VAL
 20      CONTINUE
      END IF
      END

**GRGI03 -- PGPLOT GIF driver, fill rectangle
*+
      SUBROUTINE GRGI03 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY
!      BYTE PIXMAP(BX,BY)
      integer*1 PIXMAP(BX,BY)
*
* Arguments:
*  IX0, IY0        (input): Lower left corner.
*  IX1, IY1        (input): Upper right corner.
*  ICOL            (input): Color value.
*  BX, BY          (input): dimensions of PIXMAP.
*  PIXMAP   (input/output): The image data buffer.
*-----------------------------------------------------------------------
      INTEGER IX, IY
!      BYTE VAL
      integer*1 VAL
C
      VAL = ICOL
      DO 20 IY=IY0,IY1
         DO 10 IX=IX0,IX1
            PIXMAP(IX,IY) = VAL
 10      CONTINUE
 20   CONTINUE
      END

**GRGI04 -- PGPLOT GIF driver, fill image line
*+
      SUBROUTINE GRGI04(NBUF,RBUF,BX,BY,PIXMAP,MAXIDX)
      INTEGER I,J,NBUF,BX,BY,N,IC,MAXIDX
      REAL RBUF(NBUF)
!      BYTE PIXMAP(BX,BY)
      integer*1 PIXMAP(BX,BY)
*-
      I = NINT(RBUF(1))+1
      J = BY-NINT(RBUF(2))
      DO 10 N=3,NBUF
         IC=RBUF(N)
         PIXMAP(I+N-3,J)=IC
         MAXIDX=MAX(MAXIDX,IC)
 10   CONTINUE
      END

**GRGI06 -- PGPLOT GIF driver, write GIF image                 
*+
      SUBROUTINE GRGI06 (UNIT, BX, BY, CTABLE, PIXMAP, MAXIDX, CODE)
      INTEGER UNIT, BX, BY, MAXIDX
      INTEGER CTABLE(3,0:255)
!      BYTE PIXMAP(BX * BY)
      integer*1 PIXMAP(BX * BY)
      INTEGER*2 CODE(0:4097,0:255)
*
* Write GIF image to UNIT.
*
* Arguments:  
* UNIT   (input): Output unit
* BX,BY  (input): `Screen' size
* CTABLE  (input): Color map
* PIXMAP (input): Image data
* MAXIDX (input): maximum color index used.
*--
* 16-Nov-94: fixed bug (BYTE is signed)
*-----------------------------------------------------------------------
      CHARACTER GIF1*6, GIF2*7, GIF3*3, GIF4*10
      CHARACTER*2 GRGI09
      INTEGER BMAX, BMULT, BREST, BOUT
      INTEGER PIXEL, I, J, K, M, CLEAR, EOI, TABLE, IN, TOTAL, PRE, EXT
      INTEGER OLDPRE, BITS
!      BYTE BLKOUT(0:254)
      integer*1 BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT

      BITS = 1
 10   IF (MAXIDX .LT. 2**BITS) GOTO 20
      BITS = BITS + 1
      GOTO 10
 20   CONTINUE
*
* Write Header.
*
      GIF1 = 'GIF87a'
c     I = GRWFCH(UNIT, GIF1)
      write(unit, '(a,$)') gif1
c     IF (I.NE.6) CALL GRWARN ('Error writing GIF header')
*
* Write Logical Screen Descriptor (screen width, screen height,
* color data, background color index [0], pixel aspect ratio [0]).
*
      GIF2(1:2) = GRGI09(BX)
      GIF2(3:4) = GRGI09(BY)
      GIF2(5:5) = CHAR(128 + 17 * (BITS - 1))
      GIF2(6:6) = CHAR(0)
      GIF2(7:7) = CHAR(0)
c     I = GRWFCH(UNIT, GIF2)
      write(unit, '(a,$)') gif2
*
* Write Global Color Table.
*
      DO 30 J=0,2**BITS-1
         GIF3(1:1) = CHAR(CTABLE(1,J))
         GIF3(2:2) = CHAR(CTABLE(2,J))
         GIF3(3:3) = CHAR(CTABLE(3,J))
c        I = GRWFCH(UNIT, GIF3)
         write(unit, '(a,$)') gif3
 30   CONTINUE
*
      PIXEL = MAX(BITS, 2)
*
* Write Image Descriptor.
*
      GIF4(1:1) = ','
      GIF4(2:3) = GRGI09(0)
      GIF4(4:5) = GRGI09(0)
      GIF4(6:7) = GRGI09(BX)
      GIF4(8:9) = GRGI09(BY)                   
      GIF4(10:10) = CHAR(0)
c     I = GRWFCH(UNIT, GIF4)
      write(unit, '(a,$)') gif4
*
* Write Table Based Image Data, in sub-blocks of up to 255 bytes.
*
c     I = GRWFCH(UNIT, CHAR(PIXEL))
      write(unit, '(a,$)') char(pixel)
C
C LZW-compression; initialize counters; define clear code and EOI code.
C Start packing variable-size codes into 8-bit bytes.
C Push a clear code first.
C `Read' first character.
C
      DO 100 M=0,255
         DO 100 K=0,4095
  100       CODE(K,M)=0
      CLEAR=2**PIXEL
      EOI=CLEAR + 1
      BREST=0
      BOUT=0
      BMULT=1
      BMAX=CLEAR*2
      CALL GRGI07(UNIT, CLEAR)
      IN=1
      TOTAL=BX*BY
      PRE=PIXMAP(IN)
      IF (PRE.LT.0) PRE = PRE+256
*
* Start new data stream at line 310:
* 2**n-1  (n+1)-bit codes
* 2*2**n  (n+2)-bit codes
* 4*2**n  (n+3)-bit codes
*    .         .      .
*   1024     11-bit codes
*   2048     12-bit codes (incl. one clear code)
*
  310 TABLE=EOI
      BMAX=CLEAR*2
*
* `Read' next character; check if combination prefix&extension occurred earlier
*
  320 IF (IN.GE.TOTAL) GOTO 350
      IN=IN+1
      EXT=PIXMAP(IN)
      IF (EXT.LT.0) EXT = EXT+256
      OLDPRE=PRE
      PRE=CODE(PRE,EXT)
      IF (PRE.GT.0) GOTO 320
*
* If no earlier occurrence add combination to table
*
      TABLE=TABLE+1
      CALL GRGI07(UNIT, OLDPRE)
      CODE(OLDPRE,EXT)=TABLE
      PRE=EXT
      IF (TABLE.EQ.BMAX) BMAX=BMAX*2
      IF (TABLE.LT.4095) GOTO 320
      CALL GRGI07(UNIT, CLEAR)
      DO 330 M=0,255
         DO 330 K=0,4095
  330       CODE(K,M)=0
      GOTO 310
*
* Last character
*
  350 CALL GRGI07(UNIT, PRE)
      CALL GRGI07(UNIT, EOI)
      IF (BMULT.GT.1) CALL GRGI08(UNIT, BREST)
      IF (BOUT.GT.0) THEN
         BLKOUT(0) = BOUT
c        I = GRWFIL (UNIT, BOUT+1, BLKOUT(0))
         write(unit, '(a,$)') blkout(0:bout)
         BOUT = 0
      END IF
      BLKOUT(0) = 0
c     I = GRWFIL (UNIT, 1, BLKOUT(0))
      write(unit, '(a,$)') blkout(0)
*
* Write GIF Trailer.
*
c     I = GRWFCH (UNIT, ';')
      write(unit,'(a,$)') ';'
      END

**GRGI07 -- Compile GIF output code
*
      SUBROUTINE GRGI07(UNIT, INCODE)
      INTEGER UNIT, INCODE
      INTEGER BMAX, BMULT, BREST, BOUT
!      BYTE BLKOUT(0:254)
      integer*1 BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT
C
      BREST = BREST + BMULT * INCODE
      BMULT = BMULT * BMAX
C
   10 IF (BMULT .LT. 256) RETURN
      CALL GRGI08(UNIT, BREST)
      BREST = BREST / 256
      BMULT = BMULT / 256
      GOTO 10
C
      END

**GRGI08 -- Compile and write GIF output buffer
*
      SUBROUTINE GRGI08(UNIT, INCODE)
      INTEGER UNIT, INCODE, I
      INTEGER BMAX, BMULT, BREST, BOUT
!      BYTE BLKOUT(0:254)
      integer*1 BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT
C
      BOUT = BOUT + 1
      BLKOUT(BOUT) = INCODE
      IF (BOUT .LT. 254) RETURN
      BLKOUT(0) = 254
c     I = GRWFIL(UNIT, 255, BLKOUT(0))
      write(unit, '(a,$)') blkout
      BOUT = 0
      END

**GRGI09 -- Encode integer in 2-char string
*
      CHARACTER*2 FUNCTION GRGI09(I)
      INTEGER I
      INTEGER I1, I2
*
      I1 = MOD(I,256)
      I2 = MOD(I/256,256)
      GRGI09(1:1) = CHAR(I1)
      GRGI09(2:2) = CHAR(I2)
      END
