        subroutine limitm(xl,yl,xu,yu)
 
c       Scales graph to fit on plotter.

c       GKS Version.  This allows all the co-ordinate transformations to be
c       done by GKS, all you need to do is communicate the (null)
c       transformations and the size of the papers back to the device
c       independent routines.
 
        real xl,yl,xu,yu
 
c       Common block for the user to hardware co-ordinate conversion.
        real fx, xb, fy, yb
        common/conv/fx, xb, fy, yb                                              

c       Screen sizes and offsets in hardware co-ordinates.
        real xpap, ypap, xoff, yoff
        integer jspare
        common/area/xpap, ypap, xoff, yoff, jspare                              

        fx=1.0
        xb=0.0
        xpap=abs(xu-xl)
        xoff=0.0
        fy=1.0
        yb=0.0
        ypap=abs(yu-yl)
        yoff=0.0

c       Set the normalisation transformation (continued from PLTOPN).
c       This is the transformation from the user's co-ordinates (called 
c       world co-ordinates) onto the GKS intermediate space.
c       We wish to have a co-ordinate system that corresponds to the
c       device's physical pixels, so our world co-ordinate range is;
        call gswn(1, xl, xu, yl, yu)
c       (This is known as the normalisation transformation window.)
c       And implement this normalisation.
        call gselnt(1)
c       Now make sure that the cursor uses this normalisation on returning
c       co-ordinates, by setting its priority to higher than normalisation
c       transformation zero (the default).
        call gsvpip(1,0,0)

c       Set the character size. 
        call chrdef()

        end
