        subroutine pltopn(if)
 
c       Initialises  everything,  changes  to  graphics  mode  and  clears
c       graphics screen.

c       GKS Version Tim Naylor.

c       Calls the ARK system routines arkgsm, arkssm.

c       Passed variable, a free unit number.
        integer if
 
        character*4 device, system

        integer kasfs(13), kwktyp, kerror, kunits, krastx, krasty
        integer ierr, idevcl, idummy, icola
        real xsizex, xsizey
        logical set1, set2

        logical debug
        common /bug/ debug

        logical open
        common /gks_plot/ open

c       functions called.
        logical arkssm, arkgsm

        include '/star/include/gks_par'

c       Now this little lot is needed for GESC which tells the 
c       cursor to get the key struck as well.
        integer ia(5), lstr(1), ier, liesc, loesc
        character*80 str, iescdr(1), oescdr(1)
        real ra(1)
        data ia/1, glocat, 1, gchoic, 2/
                                                                 
c       This will make it so all attributes are individual.
        data kasfs/13*1/
        data open /.false./

c       Close the workstation if open.
        if (open) then
          call pltend()
        else
c         Has the device already been chosen?
          set1=arkgsm('GKS_DEVICE', device)
100       if (.not. set1) then
c           If not, then prompt for it.
            print*, '* Under RAL GKS the ARK plotting package ',
     &      'works with the;'
            print*, '* Digisolve Ikon (GKS device 3200)'
            print*, '* Vax Workstation (GKS device 1742)'
            print*, '* Canon Laser printer (GKS device 2600)'
            print*, '> Which GKS device number are you using?'
            read (*, *,err=100) kwktyp
            write (device, '(i4)') kwktyp
	    set2=arkssm('GKS_DEVICE', device)
            if (set2) print*, 
     &      '* The symbol has now been set for future reference.'
          else
            read (device,'(i4)',err=100) kwktyp
          end if
        end if

c       Open the system.  The argument is the unit number to send
c       error messages to.  It is ignored in RAL GKS for VMS systems,
c       and should be set to 6 for RAL GKS UNIX systems.
        call gopks(6, -1)
        open=.true.
 
c       Open the workstation. For simplicity, call it workstation one
c       (the first argument).  The second argument is the output 
c       device number, which is the standard output in UNIX and
c       should be set to 0 in VMS.
        set1=arkgsm('ARK_OS', system)
        if (system(1:3) .eq. 'VMS') then
          call gopwk(1,0,kwktyp)
        else
          call gopwk(1,3,kwktyp)
        end if
        if (.not. set1) print*, 'WARNING:: Assuming this is a UNIX.'
c       Activate the workstation.
        call gacwk(1)
c       Clear workstation if not already clear.
        call gclrwk(1,0)

        if (system .ne. 'VMS') then
c         We always want to associate the locator device with the
c         choice device (i.e. whenever you hot a key for the cursor,
c         you also get the key struck returned).  We achieve this for
c         RAL GKS 7.4 by:
          call gprec(5, ia, 0, ra, 0, lstr, str, 1, ier, liesc, iescdr)
          call gesc(-1, liesc, iescdr, 1, loesc, oescdr)
        end if

c       Define all attributes as individual (see data statement for kasfs).
        call gsasf(kasfs)
 
c       Inquire the size of the work station (we want pixels).
        call gqdsp(kwktyp,kerror,kunits,xsizex,xsizey,krastx,krasty)
        if (debug) print*, 
     &  '@ The device is ', krastx, ' by ', krasty, ' pixels.'
        if (debug .and. kunits.eq.0) print*, 
     &  '@ Or ', xsizex, ' by ', xsizey, ' metres.'
c       Inquire the number of colour levels available.
cTEK    call gqeci(1,0,ierr,idevcl,idummy)
        call gqcf(kwktyp,ierr,idummy,icola,idevcl)
        if (ierr .ne. 0) then
          print*, '* Warning, GKS S/R GQCF reports error ', ierr
        end if
        if (debug) then
          print*, '@ and has ', idevcl, ' colour levels,'
          if (icola .eq. 1) then
            print*, '@ which are in colour.'
          else if (icola .eq. 0) then
            print*, '@ which are in black and white.'
          else
            print*, '@ but gqcf returns icola is ', icola
          end if
        end if
c       But 1 is used for the forground, and one for the background.
        idevcl=idevcl-2
 
c       Set the workstation transformation.
c       GKS works through an intermediate space which is square, and of
c       co-ordinate range (0,0) to (1,1).  Thus, if we want a rectangular
c       window we must choose a subset of it to display.  So we display
c       the following subset (which is known as the work station window);
        call gswkwn(1, 0.0, 1.0, 0.0, xsizey/xsizex)
c       That subset should be mapped onto the whole of the device's screen,
c       so we create a work station view port equal to the whole screen.
        call gswkvp(1, 0.0, xsizex, 0.0, xsizey)

c       Set the normalisation transformation window (continued in LIMITM).
c       This should map onto the same region of the intermediate space
c       (via the normalisation transformation viewport) as the work station
c       window, thus;
        call gsvp(1, 0.0, 1.0, 0.0, xsizey/xsizex)

        call font('Q')

        end
