        SUBROUTINE GRFPLT(MODEX,MODEY,LINE,IPOINT,IPLOT,X,Y,N)
C
C  ROUTINE TO AUTOMATICALLY PLOT AND LABEL DATA
C
C  H.E.HUCKLE MSSL JUNE 81
C
C        MODEX/Y = 1/2 =LIN/LOG
C        LINE =0 -5 = NO LINE/SOLID LINE/DASHED LINES
C      IPOINT= 0-5 =NO POINTS /+,X,O,#,*/
C      IPLOT=0-2=NO SCALE,NO AXIS,NO LABELS/SCALE+AXIS/SCALE+AXIS+LABELS
C
        LOGICAL*1 LPOINT(5),LPAT(4,4),LFORM(2)
        REAL X(1),Y(1),RMAX(2),RMIN(2),PMAX(2),PMIN(2),SETVAL(2,2)
        REAL*4 TITLEX(3),TITLEY(3),ANG(3),PAT(4),RDIST(2)
        INTEGER*2 LAY(2,2),MODE(2),ISEP(2),IVAL(2,2)
        REAL*4 DIF(2),RL(2),RH(2),TICK(2)
        INTEGER*2 NBEST(2)
        INTEGER*2 NFIG(2),NW(2),NLGMX(2),NLGMN(2),ISIGN(2)
        COMMON/GRFCOM/PMIN,PMAX
        DATA ISIGN/1,-1/
        DATA ICALL/0/
        ICALL=1
C
        IF(N.LE.0)GO TO 900
        MODE(1)=MODEX
        MODE(2)=MODEY
C
C  GET MAX AND MIN
C
        CALL MNMXAR(X,N,RMIN(1),RMAX(1))
        CALL MNMXAR(Y,N,RMIN(2),RMAX(2))
        DO 700 ID=1,2
        IF(IVAL(1,ID).EQ.1)RMIN(ID)=SETVAL(1,ID)        !OVERRIDE?
        IF(IVAL(2,ID).EQ.1)RMAX(ID)=SETVAL(2,ID)        !OVERRIDE?
        IVAL(1,ID)=0        !RESET
        IVAL(2,ID)=0
700        CONTINUE
C
C  DET BEST NO. OF DIVISIONS
C
        IF(IPLOT.LE.0)GO TO 503        !SKIP SCALING
        DO 200 ID=1,2
        IF(MODE(ID).LT.1.OR.MODE(ID).GT.2)GO TO 901        !INVALID PLOT MODE?
        RATIO=1000.
C
        GO TO (202,203),MODE(ID)
203        CONTINUE
        IF(RMAX(ID).LE.0.0)GO TO 902
        IF(RMIN(ID).LE.0.0)GO TO 902        !INVALID LOG PLOT?
        RMAX(ID)=INT(ALOG10(RMAX(ID))+16000)-16000+1        !CONV TO LOG
        RMIN(ID)=INT(ALOG10(RMIN(ID))+16000)-16000
C
202        CONTINUE
        DIF2=RMAX(ID)-RMIN(ID)
C
        DO 201 NG=1,5
        CALL LINSC2(RMIN(ID),RMAX(ID),NG,PMN,PMX,NN,RDIST(ID))
        DIF1=PMX-PMN
        RAT=DIF1/DIF2
        IF(RAT.GE.RATIO)GO TO 201
        NBEST(ID)=NN
        RATIO=RAT
        PMIN(ID)=PMN
        PMAX(ID)=PMX
C
        GO TO (204,205),MODE(ID)
204        CONTINUE
        CALL FRMPLT(PMIN(ID),PMAX(ID),RDIST(ID),LFORM(ID),NFIG(ID),
     +        NW(ID))                !LIN FORMAT
        GO TO 201
205        CONTINUE
        MINP=PMN
        MAXP=PMX
        IDIF=MAXP-MINP
        IREM=IDIF-(IDIF/NN)*NN
        IF(IREM.NE.0)MAXP=MAXP+NN-IREM
        NLGMX(ID)=MAXP
        NLGMN(ID)=MINP
        NW(ID)=3
        GO TO 201
C
201        CONTINUE
C
200        CONTINUE
C
C  SET UP SCALING
C
C   1ST TICK SIZE
C
        DO 300 ID=1,2
        DIF(ID)=PMAX(ID)-PMIN(ID)
        TICK(3-ID)=0.02*DIF(ID)
300        CONTINUE
C
C  2ND CHARACTER SIZE
C
        FACT=0.8
        IF(MODE(1).EQ.2.OR.MODE(2).EQ.2)FACT=1
        CBASE=TICK(2)*FACT
C
C
C
C  CALC BORDERS
C
        RH(1)=PMAX(1)+CBASE*4./3.*(NW(1))
        RH(2)=PMAX(2)+6.*TICK(1)
        RL(1)=PMIN(1)-CBASE*4./3.*(NW(2)+4)
        RL(2)=PMIN(2)-9.*TICK(1)
C
C
C   SET UP TITLE LOCATIONS
C
        TITLEX(1)=DIF(1)/2.+PMIN(1)        !X TITLE
        TITLEY(1)=PMIN(2)-7.*TICK(1)
        TITLEX(2)=PMIN(1)-CBASE*1.333*(NW(2)+2)
        TITLEY(2)=DIF(2)/2.+PMIN(2)
        TITLEX(3)=TITLEX(1)        !GRAPH TITLE
        TITLEY(3)=PMAX(2)+3.*TICK(1)
C
        CALL LIMITM(RL(1),RL(2),RH(1),RH(2))
C
C   SPEC CHAR SIZE
C
        CALL CHRSZU(CBASE,0.)
C
C   SPEC DASHED LINES
C
503        CONTINUE
        IF(LINE.LE.1.OR.LINE.GT.5)GO TO 505
        DATA LPAT/1,-1,1,-1,1,-1,0,-1,1,1,-1,-1,1,1,1,-1/
        DSHSZE=5
        DO 507 I=1,4
507        PAT(I)=LPAT(I,LINE-1)*DSHSZE
        CALL DSHPAT(PAT,4)
505        CONTINUE
C
C  PLOT DATA
C   1ST JOIN POINT BY LINE
C
C
        IF(LINE.LE.0.OR.LINE.GT.5)GO TO 501
        IF(LINE.GT.1)CALL DSHON
        DO 500 I=1,N
        XX=X(I)
        YY=Y(I)
        IF(MODE(1).EQ.2)XX=ALOG10(XX)
        IF(MODE(2).EQ.2)YY=ALOG10(YY)
        IF(I.EQ.1)CALL MOVXY(XX,YY)
        IF(I.GT.1)CALL LINXY(XX,YY)
500        CONTINUE
        IF(LINE.GT.1)CALL DSHOFF
501        CONTINUE
C
C   NOW DRAW POINTS
C
        IF(IPOINT.LE.0.OR.IPOINT.GT.5)GO TO 506
        DO 502 I=1,N
        XX=X(I)
        YY=Y(I)
        IF(MODE(1).EQ.2)XX=ALOG10(XX)
        IF(MODE(2).EQ.2)YY=ALOG10(YY)
        CALL CENCHR(XX,YY,LPOINT(IPOINT),0)
        DATA LPOINT/'+','x','o','#','*'/
502        CONTINUE
506        CONTINUE
C
C  DRAW AXES
C
        IF(IPLOT.LT.1)GO TO 404        !SKIP AXES
        DO 400 ID=1,2
        ID1=ID-1
        TEMP=TICK(ID)*ISIGN(ID)
        GO TO (402,403),MODE(ID)
402        CONTINUE
        DIST=DIF(ID)/NBEST(ID)
        CALL LNAX(ID1,TEMP,PMIN(1),PMIN(2),DIST,NBEST(ID))
        GO TO 400
403        CONTINUE
 
        NCYC=(NLGMX(ID)-NLGMN(ID))
        DIST=DIF(ID)/NCYC
        CALL LGAX(ID1,TEMP,PMIN(1),PMIN(2),DIST,
     +        NCYC)
400        CONTINUE
C
C   DRAW  LABELS
C
        IF(IPLOT.LT.2)GO TO 404
        DO 401 ID=1,2
        TEMP=DIF(ID)/NBEST(ID)
        IF(MODE(ID).EQ.1)CALL LNLBVL(PMIN(ID),TEMP)        !LABEL VALUES
        IF(MODE(ID).EQ.2)CALL LGLBVL(NLGMN(ID),1)
        CALL LAYUT(LAY(ID,MODE(ID)))        !LABEL LAYOUT
        IF(MODE(ID).EQ.1)
     +  CALL LABFRM(LFORM(ID),NFIG(ID))
        IF(MODE(ID).EQ.1.AND.LFORM(ID).EQ.'I'.AND.ID.EQ.1)CALL LAYUTM
        CALL LBLA(MODE(ID),ID-1,ISEP(ID))        !DRAW LABELS
401        CONTINUE
404        CONTINUE
        DATA LAY/2,4,3,4/        !WHETHER LAYUTB.M.P.E
        DATA ISEP/-2,-1/        !DISPLACEMENT OF LABELS FROM AXIS
C
C  EXIT
C
900        CONTINUE
        RETURN
C
901        CONTINUE
        WRITE(5,100)
100        FORMAT(' INVALID PLOTTING MODE IN GRFPLT CALL')
        RETURN
C
902        CONTINUE
        WRITE(5,101)
101        FORMAT(' ATTEMPT TO LOG PLOT ZERO/-VE DATA IN GRFPLT')
        RETURN
C
903        CONTINUE
        WRITE(5,102)
102        FORMAT(' CALL TO TITLX/Y/G PRIOR TO GRFPLT ')
        RETURN
C
C   TITLEING ROUTINES
C
        ENTRY TITLX(X,N)
        MODET=1
        GO TO 600
C
        ENTRY TITLY(X,N)
        MODET=2
        GO TO 600
C
        ENTRY TITLG(X,N)
        MODET=3
600        CONTINUE
        IF(ICALL.EQ.0)GO TO 903
        CALL POSTXT(0)
        CALL SWPANG
        CALL TXANGM(ANG(MODET))
        DATA ANG/0.,90.,0./
        CALL TXTM(TITLEX(MODET),TITLEY(MODET),X,N)
        CALL SWPANG
        CALL POSTXT(-1)
        RETURN
C
        ENTRY LIMPLT(MINMAX,IDIM,VAL)
        IF(MINMAX.LT.1.OR.MINMAX.GT.2)RETURN
        IF(IDIM.LT.1.OR.IDIM.GT.2)RETURN
        SETVAL(MINMAX,IDIM)=VAL
        IVAL(MINMAX,IDIM)=1
        DATA IVAL/4*0/
        RETURN
C
        END
