        subroutine lglbl(nway,xstart,ystart,dist,ns)
 
c       Log axis labels routine.
c       nway specifies direction
c            1) 0 = x direction, 1 = y direction and  (xstart,  ystart)  is
c            the postion of the bottom left corner of the left character of
c            the label.
c            2) 2 = x direction, 3 = y direction and (xstart, ystart)is the
c            the  position  of  the  bottom  left  corner of the axis to be
c            labelled.
c       dist is the separation between labels on the plot.
c       ns is the no. of intervals
 
c       A device independent version that uses smaller characters for  the
c       power of 10 if available.                     Tim Naylor May 1987.
 
        use arkplot_subs

        include 'comfil.inc'
        character*1 lab1(20)
        character*20 lab2
        equivalence(lab1(1),lab2)
 
c       First decide what the first label is.
        if (istrt .eq. 0) then
          call pltcls()
          print*,'Error message from plotting package s/r lnlbl.'
          print*,'Neither limit or lnlbvl has been called.'
          stop
        else if (istrt .eq. 1) then
          if (nway.eq.0 .or. nway.eq.2) then
            first=xstrt
          else if (nway.eq.1 .or. nway.eq.3) then
            first=ystrt
          end if
          step=dist
        else if (istrt .eq. 2) then
          first=start
          istrt=0
        else if (istrt .eq. 3) then
          first=start
          istrt=1
        end if
 
        do 100 i=1,ns+1
          flabel= first+(i-1)*step
          write(lab2,15)nint(flabel)
15        format(i20)
          call dblank(lab2)
          lab2='10'//char(92)//'u'//lab2(1:15)
c         (The char(92) avoids special meanings of \ to compiler.)
          call txtlen(lab2, 0.0, xlen, ylen)
c         Now work out the positions.
          if (nway .eq. 0)then
            xplot=xstart+(i-1)*dist
            yplot=ystart
          else if (nway .eq. 1) then
            yplot=ystart+(i-1)*dist
            xplot=xstart
          else if (nway .eq. 2) then
            xplot=xstart + (i-1)*dist - 0.5*xlen
            yplot=ystart - 1.3*ychsiz
          else if (nway .eq. 3) then
            yplot=ystart + (i-1)*dist - 2.0*ychsiz/7.0
            xplot=xstart - xlen - xchsiz/4.0
          end if
c         And plot them.
          call txtm(xplot,yplot,lab1,20)
100     continue
 
c       Tell the default axis labelling where the numbers are.
        if (nway.eq.1 .or. nway.eq.3)  then
          yxpos=xplot-0.6*xchsiz
          yypos=ystart+0.5*dist*real(ns)
        else if (nway.eq.0 .or. nway.eq.2) then
          xxpos=xstart+0.5*dist*real(ns)
          xypos=yplot-ychsiz
        end if
 
110     return
        end
