        subroutine limit(sxl, syl, sxh, syh, xmin, ymin, xmax, ymax)
 
c       This routine can be used as  an  alternative  to  limitm.  The  co-
c       ordinates  (sxl,syl) and (sxh, syh) are the positions of the lowest
c       x and y values (usually the bottom left corner) and highest x and y
c       values (usually the top right corner), as a percentage of the available
c       plotting  area.  Typical values might be (15.0, 15.0) (95.0, 95.0).
c       The paramters (xmin, ymin) and (xmax, ymax) are the same  positions
c       but in data co-ordinates.
 
c       Device independent version.  Tim Naylor, May 1986.
 
        use arkplot_subs
 
        include 'comfil.inc'
 
        if (sxh-sxl .eq. 0.0) then
          call errhnd('LIMIT', 'SEVERE ERROR', 'X PERCENTAGES SAME')
          goto 900
        else
          xfac=(xmax-xmin)/(sxh-sxl)
        end if
        if (syh-syl .eq. 0.0) then
          call errhnd('LIMIT', 'SEVERE ERROR', 'Y PERCENTAGES SAME')
          goto 900
        else
          yfac=(ymax-ymin)/(syh-syl)
        end if
        call limitm(xmin-xfac*sxl, ymin-yfac*syl, xmax+xfac*(100.0-sxh),
     +  ymax+yfac*(100.0-syh) )
 
c       Tell the label routines the default start labels.
        xstrt=xmin
        ystrt=ymin
        istrt=1
c       And where the title is to go (always at the physical top left of
c       of the graph, even of the sense of the axes is swapped).
        if (xfac .gt. 0.0) then
          txpos=xmin
        else
          txpos=xmax
        end if
        if (yfac .gt. 0.0) then
          typos=ymax+0.5*ychsiz
        else
          typos=ymin+0.5*ychsiz
        end if
 
 
        call errhnd('LIMIT', 'SUCCESS', ' ')
900     end
