        subroutine linsc2(xmin,xmax,n,xminp,xmaxp,np,dist)
 
c       xmin    minimum of data values
c       xmax    maximum of data values
c       n       approximate number of divisions desired
c       xminp   returned new minimum value
c       xmaxp   returned new maximum value
c       np      returned number of divisions
c       punched : ajn 131178
 
        dimension vint(4),sqr(3)
        data vint/1.0,2.0,5.0,10.0/
        data sqr/1.414214,3.162278,7.071068/
        data del/0.00002/
 
        if(xmax.eq.xmin) then
          call errhnd ('LINSC2', 'ERROR',
     &    'REQUESTED MAX AND MIN THE SAME')
          goto 900
        else if (xmin .gt. xmax) then
          call errhnd ('LINSC2', 'ERROR',
     &    'REQUESTED MAX SMALLER THAN MIN')
          goto 900
        end if
 
        if (n .eq. 0) then
          call errhnd('LINSC2', 'WARNING',
     &    'REQUESTED INTERVALS 0, SETTING TO 1')
          ng=1
        else
          ng=n
        end if
        fn=float(ng)
        a=(xmax-xmin)/fn
        al=alog10(a)
        nal=al
        if(a.lt.1.0) nal=nal-1
        tnal=10.0**nal
        b=a/tnal
 
        do 10 i=1,3
          if(b.lt.sqr(i)) go to 20
10      continue
        i=4
 
20      dist=vint(i)*tnal
 
        fm1=xmin/dist
        m1=fm1
        if(fm1.lt.0.0) m1=m1-1
        if(abs(float(m1)+1.0-fm1).lt.del) m1=m1+1
        xminp=dist*float(m1)
 
        fm2=xmax/dist
        m2=fm2+1.0
        if(fm2.lt.-1.0) m2=m2-1
        if(abs(fm2+1.0-float(m2)).lt.del) m2=m2-1
        xmaxp=dist*float(m2)
 
        np=m2-m1
 
        call errhnd('LINSC2', 'SUCCESS', ' ')
900     end
