        subroutine lnax(id,tiksiz,x,y,dist,nd)
 
c       Linear axis drawing routine.  Draws a line starting at (x,y) in the
c       direction  defined by id with a tick size tiksiz on the 'inside' of
c       the axis (use negative numbers if you want  them  on  the  outside)
c       with nd intervals of dist between tick marks.
c       id defines direction of axis as :-
c       id=0 +x direction    ticks above axis
c       id=1 +y direction    ticks on left of axis
c       id=2 -x direction    ticks below axis
c       id=3 -y direction    ticks on right of axis
c                         MSSL Compatable version by Mark Walker Feb. 1986.
 
 
        if (id.eq.0 .or. id.eq.1) then
          x1=x+real(nd*dist*(1-id))
          y1=y+real(nd*dist*id)
          call movxy(x,y)
          call linxy(x1,y1)
          i=id
          tick=tiksiz
        else if (id.eq.2 .or. id.eq.3) then
          x1=x
          y1=y
          call movxy( x-real(nd*dist*(3-id)), y-real(nd*dist*(id-2)) )
          call linxy(x1,y1)
          i=id-2
          tick=-tiksiz
        else
          call pltcls()
          print*, 'Error in call to plotting package subroutine'
          print*, 'lnax.  Axis direction number = i =', i
        end if
 
        do 10 j = 0,nd
          call movxy(x1-real(dist*j*(1-i))-real(((-1)**j)*i*
     +    tick*0.5)-real(tick*i*0.5),y1-real(dist*i*j)-
     +    real(tick*(1-i)*0.5*((-1)**j))+real(tick*(1-i)*0.5))
          call linxy(x1-real(dist*j*(1-i))+real(((-1)**j)*i*
     +    tick*0.5)-real(tick*i*0.5),y1-real(dist*j*i)+real(tick
     +    *(1-i)*((-1)**j))+real(tick*0.5*(1-i)*(1-(-1)**j)))
10      continue
 
        return
        end
 
 
 
        subroutine lnxax(tick,x,y,dist,nint)
c       Included for MSSL compatability.
        call lnax(0,tick,x,y,dist,nint)
        return
        end
 
        subroutine lnyax(tick,x,y,dist,nint)
c       Included for MSSL compatability.
        call lnax(1,tick,x,y,dist,nint)
        return
        end
