        subroutine lnlbl(nway,xstart,ystart,dist,ns)
 
c       nway specifies direction
c            1) 0 = x direction, 1 = y direction and  (xstart,  ystart)  is
c            the postion of the bottom left corner of the left character of
c            the label.
c            2) 2 = x direction, 3 = y direction and (xstart, ystart)is the
c            the  position  of  the  bottom  left  corner of the axis to be
c            labelled.
c       dist is the separation between labels on the plot.
c       ns is the no. of intervals
c       Original by Robin Corbet.  New version (including free format
c       labels and default positioning) Tim Naylor March 1986.
 
        use arkplot_subs
 
        character*1 lab1(20)
        character lab2*20, formt*10
        equivalence(lab1(1),lab2)
        integer form
 
        if (nway.lt.0 .or. nway.gt.3) then
          call pltcls()
          print*,'Error message from plotting package s/r lnlbl.'
          print*,'Subroutine called in unknown nway', nway
          stop
        end if
 
        if (istrt .eq. 0) then
          call pltcls()
          print*,'Error message from plotting package s/r lnlbl.'
          print*,'Neither limit or lnlbvl has been called.'
          stop
        else if (istrt .eq. 1) then
          if (nway.eq.0 .or. nway.eq.2) then
            first=xstrt
          else if (nway.eq.1 .or. nway.eq.3) then
            first=ystrt
          end if
          step=dist
        else if (istrt .eq. 2) then
          first=start
          istrt=0
        else if (istrt .eq. 3) then
          first=start
          istrt=1
        end if

c       The X start position of the y-labels changes, depending on their
c       length.  For positioning the y-axis title we want the position of
c       the biggest label (bxlab), which is chosen by making it the one
c       with the largest label, whose length is bxlen.
        bxlen=0.0
 
c       The following positions to plot the labels in can be decided here.
        if (nway .eq. 0) then
          yplot=ystart
        else if (nway .eq. 1) then
          xplot=xstart
        else if (nway .eq. 2) then
          yplot=ystart - 1.3*ychsiz
        end if
c       nway=3 must wait until we know how many characters there are.
 
        if (af.eq.'f' .or. af.eq.'F') then
c         "f" format.
          do 190 i=1, ns+1
            flabel=first + real(i-1)*step
            write(lab2,110)flabel
110         format(f20.5)
            call dblank(lab2)
            call dexp(lab2)
            call txtlen(lab2, 0.0, xlen, ylen)
            if (nway .eq. 3) then
              xplot=xstart - xlen - 0.2*xchsiz
              if (xlen .gt. bxlen) then
                bxplot=xplot
                bxlen=xlen
              end if
            end if
            if (nway .eq. 0) then
              xplot=xstart+(i-1)*dist
            else if (nway .eq. 1) then
              yplot=ystart+(i-1)*dist
            else if (nway .eq. 2) then
              xplot=xstart - 0.5*xlen + (i-1)*dist
            else if (nway .eq. 3) then
              yplot=ystart - 2.0*ychsiz/7.0 + (i-1)*dist
            end if
            call txtm(xplot,yplot,lab1,20)
190       continue
        else if (af.eq.'i' .or. af.eq.'I') then
c         Integer format.
          do 290 i=1, ns+1
            flabel=first + real(i-1)*step
            write(lab2,210)nint(flabel)
210         format(i20)
            call dblank(lab2)
            call txtlen(lab2, 0.0, xlen, ylen)
            xplot=xstart - xlen - 0.2*xchsiz
            if (nway .eq. 0) then
              xplot=xstart+(i-1)*dist
            else if (nway .eq. 1) then
              yplot=ystart+(i-1)*dist
            else if (nway .eq. 2) then
              xplot=xstart - 0.5*xlen + (i-1)*dist
            else if (nway .eq. 3) then
              yplot=ystart - 2.0*ychsiz/7.0 + (i-1)*dist
              xplot=xstart - xlen - 0.2*xchsiz
              if (xlen .gt. bxlen) then
                bxplot=xplot
                bxlen=xlen
              end if
            end if
            call txtm(xplot,yplot,lab1,20)
290       continue
        else if (af .eq. '*') then
          if (dist .gt. 0.0) then
            call dec10(first, first+step*ns, step, form, nchar, formt)
          else           
            call dec10(first+step*ns, first, step, form, nchar, formt)
          end if
          do 390 i=1, ns+1
            flabel=first + real(i-1)*step
            if (form .eq. 0) then
              write (lab2,formt) nint(flabel)
            else
              write (lab2,formt) flabel
            end if
            call dblank(lab2)
            call dexp(lab2)
            call txtlen(lab2, 0.0, xlen, ylen)
            if (nway .eq. 0) then
              xplot=xstart+(i-1)*dist
            else if (nway .eq. 1) then
              yplot=ystart+(i-1)*dist
            else if (nway .eq. 2) then
              xplot=xstart - 0.5*xlen + (i-1)*dist
            else if (nway .eq. 3) then
              yplot=ystart - 2.0*ychsiz/7.0 + (i-1)*dist
              xplot=xstart - xlen - 0.2*xchsiz
              if (xlen .gt. bxlen) then
                bxplot=xplot
                bxlen=xlen
              end if
            end if
            call txtm(xplot,yplot,lab1,20)
390       continue
        else
          call pltcls()
          print*,'Error message from plotting package s/r lnlbl.'
          print*,'Format type', af, 'unknown.'
          stop
        end if
 
c       Tell the default axis labelling where the numbers are.
        if (nway.eq.1 .or. nway.eq.3)  then
          if (bxlen .gt. 0.0) then
            yxpos=bxplot-0.6*xchsiz
          else
            yxpos=xplot-0.6*xchsiz
          end if
          yypos=ystart+0.5*dist*real(ns)
        else if (nway.eq.0 .or. nway.eq.2) then
          xxpos=xstart+0.5*dist*real(ns)
          xypos=yplot-ychsiz
        end if
 
        return
 
910     call pltcls()
        print*,'Error message from plotting package s/r lnlbl'
        print*,'Error attempting to write axis label', flabel
        print*,'to string.'
        stop
 
        end
 
 
        subroutine dec10( minz, maxz, dist, form, nchar, formt )
 
c       minz, maxz and dist are the max and min labels, and the difference
c       between each label.
c       zn=figures after decimal place.
c       nchar=total number of chars in the number.
c       form=0 => "i" format
c       form=1 => "f" format
c       form=2 => "e" format
c       formt is returned, and is used like "write(string,formt) number"
 
        real minz, maxz, dist
        integer form, nchar, zn
        character*10 formt
        real big, temp
 
        big = max( abs( minz ), abs( maxz ) )
        if(big.ge.0.01 .and. big.le.99999.9) then
c         can use simple format.
          nchar = abs(log10(big)) + 1
c         if it's negative allow for sign.
          if( big .eq. -minz ) then
            nchar = nchar + 1
          else if( minz .lt. 0.0 ) then
            zn = int( log10( -minz ) ) + 2
            nchar = max( nchar, zn )
          end if
          if( abs(dist) .gt. 0.99998) then
c           Just print integers.
            form = 0
c           write the format statement.
            formt='(i20)'
          else
c           it's reals folks!
            form = 1
            temp = log10( abs(dist) )
            if( mod( temp, 1.0 ) .eq. 0.0 ) then
              zn = -temp
            else
              zn = -temp + 0.99999
            end if
            nchar = nchar + zn + 1
            write( formt, 130 ) zn
130         format( '(f20.', i1, ')' )
          end if
        else
c         its e somthing format.
          form = 2
          temp = log10(abs ( big / dist ) )
          if( mod( temp, 1.0 ) .eq. 0.0 ) then
c           The next line used to read.
c           zn = log10(abs( big / dist ) ) + 1
            zn = int(temp)
          else
c           The next line used to read.
c           zn = log10(abs( big / dist ) ) + 2
            zn = int(temp) + 1
          end if
          nchar = zn + 6
          if (minz .lt. 0.0) nchar=nchar+1
          write( formt, 160 ) zn
160       format( '(1pe20.', i1, ')' )
        end if
 
        return
        end
 
        subroutine dblank(text)
 
c       Removes leading blanks from text.
 
        character*(*) text
 
        do 110 i=1, len(text)
          if (text(i:i) .ne. ' ') then
            ibeg=i
            goto 120
          end if
110     continue
 
120     if (ibeg .eq. 1) goto 900
        do 130 i=ibeg, len(text)
          text(i-ibeg+1:i-ibeg+1)=text(i:i)
130     continue
        text(len(text)-ibeg+2:len(text))=' '
 
900     end
 
 
        subroutine dexp(label)
 
c       Replaces the form of exponentials.
 
        character*(*) label
 
        do 220 i=1, len(label)
          if (label(i:i) .eq. 'E') then
            label(i+5:len(label))=label(i+1:len(label)-4)
            label(i:i+4)='x10'//char(92)//'u'
c           (The char(92) avoids special meanings of \ to compiler.)
          end if
220     continue
 
        end
