        subroutine point(ityp)
 
c       Draws circle(0), cross(1), dot (2), asterisk(10),  upper limit(11),
c       black painted triangle(12) or blank triangle(13), depending on
c       ityp.
 
c       Device independent version.
 
        include 'comfil.inc'
 
c       The current position before we started.
        real oxc, oyc
 
        integer ityp
 
c       Check ityp is in range.
        if (ityp.lt.0 .or. ityp.gt.2) then
          if (ityp.lt.8 .or. ityp.gt.13) then
            call errhnd('POINT', 'ERROR', 'ILLEGAL ARGUMENT')
            goto 900
          end if
        end if
 
c       Remember the current position, but in user co-ordinates.
        oxc=xc/fx + xb
        oyc=yc/fy + yb
 
        if (ityp .eq. 0) then
c         Draw a circle.
          call m12(oxc, oyc, -1, 5)
          call l12(oxc, oyc, -3, 4)
          call l12(oxc, oyc, -4, 3)
          call l12(oxc, oyc, -5, 1)
          call l12(oxc, oyc, -5,-1)
          call l12(oxc, oyc, -4,-3)
          call l12(oxc, oyc, -3,-4)
          call l12(oxc, oyc, -1,-5)
          call l12(oxc, oyc,  1,-5)
          call l12(oxc, oyc,  3,-4)
          call l12(oxc, oyc,  4,-3)
          call l12(oxc, oyc,  5,-1)
          call l12(oxc, oyc,  5, 1)
          call l12(oxc, oyc,  4, 3)
          call l12(oxc, oyc,  3, 4)
          call l12(oxc, oyc,  1, 5)
          call l12(oxc, oyc, -1, 5)
        else if (ityp .eq. 1) then
c         Draw a cross.
c         Move to left, draw horizontal bar.
          call m12(oxc, oyc, -5,0)
          call l12(oxc, oyc, 5,0)
          call m12(oxc, oyc, 0,-5)
          call l12(oxc, oyc, 0,5)
        else if (ityp .eq. 2) then
c         Draw a dot.
          call m12(oxc, oyc, 0, 0)
          call l12(oxc, oyc, 1, 0)
        else if (ityp .eq. 9) then
c         DRAW A LOWER LIMIT OF OBSERVATIONS
c         DRAW HORIZONTAL BAR
          call m12(oxc, oyc, -5,0)
          call l12(oxc, oyc, 5,0)
c         DRAW LARGER VERTICAL BAR
          call m12(oxc, oyc, 0,0)
          call l12(oxc, oyc, 0,15)
c         DRAW ARROW
          call m12(oxc, oyc, -2,11)
          call l12(oxc, oyc, 0,15)
          call l12(oxc, oyc, 2,11)
        else if (ityp .eq. 10) then
c         Draw an asterisk.
c         DRAW HORIZONTAL BAR
          call m12(oxc, oyc, -5,0)
          call l12(oxc, oyc, 5,0)
c         DRAW VERTICAL BAR
          call m12(oxc, oyc, 0,-5)
          call l12(oxc, oyc, 0,5)
c         DRAW FIRST INCLINED BAR
          call m12(oxc, oyc, -3,4)
          call l12(oxc, oyc, 0,0)
          call l12(oxc, oyc, 3,-4)
c         DRAW SECOND INCLINED BAR
          call m12(oxc, oyc, 3,4)
          call l12(oxc, oyc, 0,0)
          call l12(oxc, oyc, -3,-4)
        else if (ityp .eq. 11) then
c         DRAW AN UPPER LIMIT OF OBSERVATIONS
c         DRAW HORIZONTAL BAR
          call m12(oxc, oyc, -5,0)
          call l12(oxc, oyc, 5,0)
c         DRAW LARGER VERTICAL BAR
          call m12(oxc, oyc, 0,0)
          call l12(oxc, oyc, 0,-15)
c         DRAW ARROW
          call m12(oxc, oyc, -2,-11)
          call l12(oxc, oyc, 0,-15)
          call l12(oxc, oyc, 2,-11)
        else if (ityp  .eq. 12 )  then
c         DRAW A BLACK TRIANGLE
          call  m12(oxc, oyc, -5,3)
          call  l12(oxc, oyc, 5,3)
          call  l12(oxc, oyc, 0,-5)
          call  l12(oxc, oyc, -5,3)
c         To distinguish from the blank triangle instead of a
c         black pattern (canon printer) we put an internal triangle.
          call m12(oxc, oyc, -3,1)
          call l12(oxc, oyc, 3,1)
          call l12(oxc, oyc, 0,-2)
          call l12(oxc, oyc, -3,1)
        else if (ityp  .eq. 13 )  then
c         DRAW A BLAnK TRIANGLE
          call m12(oxc, oyc, -5,3)
          call l12(oxc, oyc, 5,3)
          call l12(oxc, oyc, 0,-5)
          call l12(oxc, oyc, -5,3)
        end if
 
c       Return to current position
        call m12(oxc, oyc, 0,0)
 
800     call errhnd('POINT', 'SUCCESS', ' ')
 
900     end
 
 
        subroutine l12(oxc, oyc, ix,iy)
 
c       Draws a line to (oxc+ix, oyc+iy).  Note that
c       the integers ix and iy are in 1024ths
c       and 780ths of the screen size respectively.
 
        include 'comfil.inc'
        integer ix, iy
        real oxc, oyc
 
        call linxy(oxc + xpap*real(ix)/(1024.0*fx),
     &  oyc + ypap*real(iy)/(780.0*fy))
 
        end
 
 
        subroutine m12(oxc, oyc, ix,iy)
 
c       Moves the pen to (oxc+ix, oyc+iy).  Note that
c       the integers ix and iy are in 1024ths
c       and 780ths of the screen size respectively.
 
        include 'comfil.inc'
        integer ix, iy
        real oxc, oyc
 
        call movxy(oxc + xpap*real(ix)/(1024.0*fx),
     &  oyc + ypap*real(iy)/(780.0*fy))
 
        end
