	subroutine ARK_CDAT( string )
C
C	Obtains date as a string --- format can be specified by using
C	the (eventual) output string itself.  Use 3-letter code
C		!/A for mm/dd/yy (all 2 digit integers)
C		!/B for dd/mm/yy
C		!-A for Mmm-dd-yyyy (Mmm is three-character string)
C		!-B for dd-Mmm-yyyy (and yyyy is full 4 digit integer)
C		!-L for yyyy-Mmm-dd
C
	implicit none
c
	character*( * ) string
c		Must be 8 characters for slash style, 11 for dash style
	integer year, month, day
	integer slash, order
	save slash, order
c		Save style for future use
c
	character*3 mon( 12 )
	data mon / 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 
     :			'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec' /
c
	call IDATE( month, day, year )
	if( year .ge. 90 ) then
	  year = year + 1900
	else
	  year = year + 2000
	end if
C	Now check if user specified a particular style
	if( string( 1: 1 ) .eq. '!' ) then
c		string was used to specify output mode
	  if( string( 2: 2 ) .eq. '/' ) then
c			ii/jj/kk style
	    slash = 1
	    if( string( 3: 3 ) .eq. 'A'
     :				.or. string( 3: 3 ) .eq. 'a' ) then
c			American order (month/day/year)
	      order = 1
	    else
c			British order (day/month/year) (use 'b' to be sure)
	      order = 0
	    end if
	  else
c			iiii-ccc-dd style (use '-' to be sure)
	    slash = 0
	    if( string( 3: 3 ) .eq. 'A'
     :				.or. string( 3: 3 ) .eq. 'a' ) then
c			American order (month-day-year)
	      order = 1
	    else if( string( 3: 3 ) .eq. 'L'
     :				.or. string( 3: 3 ) .eq. 'l' ) then
c			Little-endian (year-mon-day)
	      order = 2
	    else
c			British order (day-month-year) (use 'b' to be sure)
	      order = 0
	    end if
	  end if
	end if
C
C	Now actually write string
	if( slash .eq. 1 ) then
	  if( order .eq. 1 ) then
c		slash, American: mm/dd/yy
	    write( string, '(i2.2,''/'',i2.2,''/'',i2.2)' )
     :			month, day, mod( year, 100 )
	  else
c		slash, British: dd/mm/yy
	    write( string, '(i2.2,''/'',i2.2,''/'',i2.2)' )
     :			day, month, mod( year, 100 )
	  end if
	else
	  if( order .eq. 1 ) then
c		dash, American: MMM-dd-yyyy
	    write( string, '(a3,''-'',i2.2,''-'',i4)' )
     :			mon( month ), day, year
	  else if( order .eq. 2 ) then
c		dash, Little-endian: yyyy-MMM-dd
	    write( string, '(i4,''-'',a3,''-'',i2.2)' )
     :			year, mon( month ), day
	  else
c		dash, British: dd-MMM-yyyy
	    write( string, '(i2.2,''-'',a3,''-'',i4)' )
     :			day, mon( month ), year
	  end if
	end if
c
	end
