        subroutine arkopn(iunit, file, filex, stat, pos, form, acces,
     &  irecl)
              
c       Opens a file with a machine independent call.  This is the VMS
c       Version.
                
c       Returned values.
c       The number of the unit opened.
        integer iunit
                     
c       Input values.
c       The file name, and the default extension to be used.
        character*(*) file, filex
c       The status to be used (OLD, NEW or UNKNOWN)
        character*(*) stat
c       The position to start writing into the file (APPEND, OVERWRITE,
c       READONLY).
        character*(*) pos
c       The form of the file (FORMATTED, UNFORMATTED or TAPE)
        character*(*) form
c       The file access (DIRECT or SEQUENTIAL), need only be supplied if
c       form is UNFORMATTED.
        character*(*) acces
c       The record length (will be divided by 4 for VMS, and the BLOCKSZIE
c       set to the input record length).  Only used if access is 'DIRECT'.
        integer irecl
                     
c       Locals.
c       All the above strings translated to upper case.
        character*80 ufile, ufilex, ustat, upos, uform, uacces
c       The error flag from UNIX_EXTEND
        integer iflag
c       For the debugger.
        logical debug
        common /bug/ debug
                     
c       Copy the strings into local variables.
        call unix_extend(file, ufile, iflag)
        ufilex = filex
        ustat  = stat
        upos   = pos
        uform  = form
c       Make all the open keywords upper case.
        call upcase(ustat)
        call upcase(upos)
        call upcase(uform)
        uacces  = 'SEQUENTIAL'
        if (uform .eq. 'UNFORMATTED') uacces = acces
        call upcase(uacces)                          
c       We had better check that pos has a legal value, as the operating
c       system won't tell us!
        if (upos  .eq. 'APPEND') then
          uacces = 'APPEND'
        else if (upos.ne.'READONLY' .and. upos.ne.'OVERWRITE') then
          print*, 'ARK S/R ARKOPN called in illegal value for POS.'
          print*, 'POS was "'//pos(1:len(pos))//'"'
          goto 900
        end if
              
c       Get a free unit.
        call find_free(iunit)

c       Write out an informational message.
        if (debug) then
          print*, '@ S/R ARKOPN is about to open the file'
          print*, '@ ', ufile
          print*, '@ With the arguments ', ustat, upos, uform, 
     &    uacces, irecl
          print*, '@ on unit ', iunit
        end if
                             
c       The hard work is done here.
        if (uform .eq. 'TAPE') then 
          open (unit=iunit, status='OLD', form='UNFORMATTED', 
     &    access='SEQUENTIAL', file=ufile, recordtype='variable')
        else if (uacces .ne. 'DIRECT') then
          if (upos .ne. 'READONLY') then
            if (uform .eq. 'FORMATTED') then
              open (unit=iunit, status=ustat, form=uform, access=uacces,
     &        defaultfile='.'//ufilex, file=ufile, 
     &        carriagecontrol='list')
            else
              open (unit=iunit, status=ustat, form=uform, access=uacces,
     &        defaultfile='.'//ufilex, file=ufile)
            end if
          else
            if (uform .eq. 'FORMATTED') then
              open (unit=iunit, status=ustat, form=uform, access=uacces,
     &        defaultfile='.'//ufilex, file=ufile, readonly,
     &        carriagecontrol='list')
            else
              open (unit=iunit, status=ustat, form=uform, access=uacces,
     &        defaultfile='.'//ufilex, file=ufile, readonly)
            end if
          end if
        else
c         Direct access.   Assume this is always unformatted.
          if (upos .eq. 'READONLY') then
            open (unit=iunit, status=ustat, form=uform, access=uacces,
     &      recl=irecl/4, blocksize=irecl, defaultfile='.'//ufilex,
     &      file=ufile, readonly)
          else
            open (unit=iunit, status=ustat, form=uform, access=uacces,
     &      recl=irecl/4, blocksize=irecl, defaultfile='.'//ufilex,
     &      file=ufile)
          end if
        end if
              
900     end
