        integer function topen(itlu, devnam, islabeled)

        integer itlu
        character*(*) devnam
        logical islabeled

        integer i

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3)
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit
        data iunit /4*-1/

        topen=0

        if (itlu.ge.0 .and. itlu.le.3) then
          call find_free(iunit(itlu))
          dunit(itlu)=devnam
        else
          print*, 'Error in ARK routine topen, itlu = ', itlu
          print*, 'itlu must be between 0 and 3.'
          topen=-1
          goto 900
        end if

        open (unit=iunit(itlu), status='OLD', form='UNFORMATTED', 
     &  access='SEQUENTIAL', file=devnam, recordtype='variable')

900     end


        integer function tread(itlu, buffer)

        integer itlu
        character*(*) buffer

        integer i

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3)
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit

c       Set tread to the end-of-file condition.
        tread=0

        if (itlu.lt.0 .or. itlu.gt.3) then
          print*, 'Error in ARK routine tread, itlu = ', itlu
          print*, 'itlu must be between 0 and 3.'
          tread = -1
          goto 900
        end if

        if (iunit(itlu) .eq. -1) then
          print*, 'Error in ARK routine tread.  Tape unit ', itlu
          print*, 'has not been opened yet.'
          tread = -1
          goto 900
        end if

        read(iunit(itlu), end=900) buffer
        tread=len(buffer)

900     end


        integer function tclose(itlu)

        integer itlu

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3)
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit

        if (itlu.lt.0 .or. itlu.gt.3) then
          print*, 'Error in ARK routine tclose, itlu = ', itlu
          print*, 'itlu must be between 0 and 3.'
          tclose = -1
          goto 900
        end if

        if (iunit(itlu) .ne. -1) close(iunit(itlu))
        iunit(itlu)=-1

900     end

        integer function tskipf(itlu, nfiles, nrecs)

        integer itlu, nfiles, nrecs

c       This array holds the fortran unit numbers corresponding to
c       tape unit numbers 0 to 3.
        integer iunit(0:3)
        character*30 dunit(0:3)
        common /arktap/ iunit, dunit

        integer i
        character*70 spawn_line

        if (nfiles .gt. 0) then
          print*, dunit(itlu)(1:5)
          write(spawn_line, 120) dunit(itlu)(1:5), nfiles
120	  format( 'SET MAGTAPE ', A5, '/SKIP=FILES:', I3.3 )
        else if (nfiles .lt. 0) then
          write(spawn_line, 130) dunit(itlu)(1:5), abs(nfiles)
130	  format( 'SET MAGTAPE ', A5, '/SKIP=FILES:-', I3.3 )
        end if
	call arkcom(spawn_line)

        if (nrecs .gt. 0) then
          do 240 i=1, nrecs
            read(iunit(itlu))
240       continue
        else if (nrecs .lt. 0) then
          print*, 'Error in ARK routine tskipf.'
          print*, 'Attempt to skip a negative number of records.'
          tskipf=-1
        end if

        end
