        subroutine wildf(fildef, extdef, lastf, lstfil)

c       Given the file specification fildef (e.g. *.*) this routine will
c       return a file name that matches it, and keep on doing so until
c       it runs out of names.  On reaching the last name in the series
c       it will return lastf as true.

c       If no files match the required specification lastf is returned
c       as true and lstfil is set equal to the input file.  This means
c       that WILDF is transparent in the case of a non-existant file.
c       The error can be caught and dealt with in an obvious way using 
c       either the FORTRAN inquire call, or ARKINQ to check for the 
c       existance of the file.

c       Passed variables.
        character*(*) fildef, lstfil, extdef
        logical lastf

c       Locals.
        character*100 safe
        integer icontext, istat, i
        include '($rmsdef)'
        include '($ssdef)'
        include '(lib$routines)'
        logical gotall

        data gotall /.true./

        lastf=.false.
        if (gotall) then
c         We got all the files corresponding to the last wild card,
c         so lets start a new one.
          istat=lib$find_file(fildef, lstfil, icontext, '.'//extdef)
          if (istat.eq.rms$_fnf) then
c           File not found.
c           End the context.
            call lib$find_file_end(icontext)
            lstfil=fildef
            lastf=.true.
            goto 900
          end if
        else
          lstfil=safe
        end if

        gotall=.false.
c       Find the next file in the list.
        istat=lib$find_file(fildef, safe, icontext, '.'//extdef)
        if (istat.eq.rms$_nmf) then
c         End the context.
          call lib$find_file_end(icontext)
c         And tell the user this is the last file.
          lastf=.true.
          gotall=.true.
        end if

c       Remove the version number in VMS, if no version number was
c       specified in fildef.
        do 220 i=1, len(fildef)
          if (fildef(i:i) .eq. ';') goto 280
220     continue
        lstfil(index(lstfil,';'):len(lstfil))= ' '
280     continue

c       If no directory was specfied in the input, it musn't be in
c       the output either (because of programs like debias which
c       create their own output file names) so,
        do 310 i=1, len(fildef)
          if (fildef(i:i).eq.']' .or. fildef(i:i).eq.':') goto 350
310     continue
c       If we get to here we do need to remove the directory name.
        do 320 i=len(lstfil), 1, -1
          if (lstfil(i:i).eq.':' .or. lstfil(i:i).eq.']') then
            lstfil=lstfil(i+1:len(lstfil))
            goto 350
          end if
320     continue
350     continue

900     end
